import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class pwd extends Applet implements ActionListener, ItemListener{

	private Button btnGo;
	private TextField tfLongueur, tfMinMin, tfMaxMin,tfMinMaj, tfMaxMaj,tfMinNb, tfMaxNb,tfMinSpc, tfMaxSpc;
	private TextField tfSpeciaux, tfMasque, tfPwd;
	private Checkbox chkMin, chkMaj, chkNb, chkSpc;
	private TabPanel test;
	private Panel PanelStandard, PanelMasque, PanelAbout;
	private Label lbl;
	private Font police;

	public void init(){

		// Initialisation panel Standard

		police = new Font("Dialog",Font.PLAIN,8);
			
		PanelStandard = new Panel();
		PanelStandard.setFont(police);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
			c.anchor = java.awt.GridBagConstraints.WEST ;
		PanelStandard.setLayout(gridbag);
		lbl = new Label("Le mot de passe doit contenir ");
		gridbag.setConstraints(lbl, c);

		PanelStandard.add(lbl);
		tfLongueur = new TextField("8",2);
		gridbag.setConstraints(tfLongueur, c);
		PanelStandard.add(tfLongueur);
			c.gridwidth = GridBagConstraints.REMAINDER; //fin de ligne
		lbl = new Label("caractre(s)",java.awt.Label.LEFT);

		gridbag.setConstraints(lbl, c);
		PanelStandard.add(lbl);

		chkMin = new Checkbox("Nombre de minuscules entre",true);
		chkMin.addItemListener(this);
			c.gridwidth = 1;
		gridbag.setConstraints(chkMin, c);
		PanelStandard.add(chkMin);
		tfMinMin = new TextField("0",2);
		gridbag.setConstraints(tfMinMin, c);
		PanelStandard.add(tfMinMin);
		lbl = new Label("et",java.awt.Label.LEFT);
		gridbag.setConstraints(lbl, c);
		PanelStandard.add(lbl);
		tfMaxMin = new TextField("8",2);
			c.gridwidth = GridBagConstraints.REMAINDER; //fin de ligne
		gridbag.setConstraints(tfMaxMin, c);
		PanelStandard.add(tfMaxMin);

		chkMaj = new Checkbox("Nombre de majuscules entre",true);
		chkMaj.addItemListener(this);
			c.gridwidth = 1;
		gridbag.setConstraints(chkMaj, c);
		PanelStandard.add(chkMaj);
		tfMinMaj = new TextField("0",2);
		gridbag.setConstraints(tfMinMaj, c);
		PanelStandard.add(tfMinMaj);
		lbl = new Label("et",java.awt.Label.LEFT);
		gridbag.setConstraints(lbl, c);
		PanelStandard.add(lbl);
		tfMaxMaj = new TextField("8",2);
			c.gridwidth = GridBagConstraints.REMAINDER; //fin de ligne
		gridbag.setConstraints(tfMaxMaj, c);
		PanelStandard.add(tfMaxMaj);

		chkNb = new Checkbox("Nombre de chiffres entre",true);
		chkNb.addItemListener(this);
			c.gridwidth = 1;
		gridbag.setConstraints(chkNb, c);
		PanelStandard.add(chkNb);
		tfMinNb = new TextField("0",2);
		gridbag.setConstraints(tfMinNb, c);
		PanelStandard.add(tfMinNb);
		lbl = new Label("et",java.awt.Label.LEFT);
		gridbag.setConstraints(lbl, c);
		PanelStandard.add(lbl);
		tfMaxNb = new TextField("8",2);
			c.gridwidth = GridBagConstraints.REMAINDER; //fin de ligne
		gridbag.setConstraints(tfMaxNb, c);
		PanelStandard.add(tfMaxNb);

		chkSpc = new Checkbox("Nombre de spciaux entre",true);
		chkSpc.addItemListener(this);
			c.gridwidth = 1;
		gridbag.setConstraints(chkSpc, c);
		PanelStandard.add(chkSpc);
		tfMinSpc = new TextField("0",2);
		gridbag.setConstraints(tfMinSpc, c);
		PanelStandard.add(tfMinSpc);
		lbl = new Label("et",java.awt.Label.LEFT);
		gridbag.setConstraints(lbl, c);
		PanelStandard.add(lbl);
		tfMaxSpc = new TextField("8",2);
			c.gridwidth = GridBagConstraints.REMAINDER; //fin de ligne
		gridbag.setConstraints(tfMaxSpc, c);
		PanelStandard.add(tfMaxSpc);

		tfSpeciaux = new TextField("`~!@#$%^&*()-_=+[{]}\\|;:'\",<.>/? ");
			c.anchor = java.awt.GridBagConstraints.CENTER ;
			c.gridwidth = GridBagConstraints.REMAINDER; //fin de ligne
		gridbag.setConstraints(tfSpeciaux, c);
		PanelStandard.add(tfSpeciaux,c);


		// Initialisation panel Masque
		PanelMasque = new Panel();
		PanelMasque.setFont(police);
		tfMasque = new TextField();
		PanelMasque.setLayout(new GridLayout(7,1));
		PanelMasque.add(new Label("a  -> Minuscule",java.awt.Label.LEFT));
		PanelMasque.add(new Label("A  -> Majuscule",java.awt.Label.LEFT));
		PanelMasque.add(new Label("8  -> Chiffre",java.awt.Label.LEFT));
		PanelMasque.add(new Label("*  -> Caractre spcial (cf. onglet standard)",java.awt.Label.LEFT));
		PanelMasque.add(new Label("\\x -> Le caractre 'x'",java.awt.Label.LEFT));
		PanelMasque.add(new Label("?  -> Au hasard",java.awt.Label.LEFT));
		PanelMasque.add(tfMasque);


		// Initialisation panel About
		PanelAbout = new Panel();
		PanelAbout.setFont(police);
		PanelAbout.setLayout(new GridLayout(6,1)); 
		PanelAbout.add(new Label("Au sujet de ...",java.awt.Label.CENTER));
		PanelAbout.add(new Label("",java.awt.Label.CENTER));
		PanelAbout.add(new Label("",java.awt.Label.CENTER));
		PanelAbout.add(new Label("Version 1.02.01b (Beta)",java.awt.Label.CENTER));
		PanelAbout.add(new Label("<mailto:java@canonne.net>",java.awt.Label.CENTER));
		PanelAbout.add(new Label("(c) 2002 Antoine CANONNE",java.awt.Label.CENTER));

		// Initialisation interface commune
		btnGo = new Button("Gnrer");
		btnGo.setFont(police);
		tfPwd = new TextField("Faites vos choix");
		tfPwd.setEditable(false);
		tfPwd.setFont(police);
		setLayout(null);
		btnGo.setBounds(5, 260, 100, 30);
		tfPwd.setBounds(110, 260, 195, 30);
		test = new TabPanel();
		test.setBounds(5, 5, 390, 250);

		test.addPanel(PanelStandard,"Standard");
		test.addPanel(PanelMasque,"Masque");
		test.addPanel(PanelAbout,"Au sujet de ...");

		add(test);
		add(btnGo);
		add(tfPwd);
		btnGo.addActionListener(this);

	}


	public void paint(Graphics g){
		g.setColor(Color.red);
		g.drawRect(0, 0, 399, 299);
	}
	
	/**
	 * Mlange une chaine de caractres
	 */
	public String randomize(String str){
		char tableau[];
		char tmp;
		int taille;
		int i;

		taille = str.length();
		tableau = new char[taille];
		str.getChars(0,taille,tableau,0);

		for(int pos=0;pos<(taille/3);pos++){
			i = (int)((Math.random()*1000)%taille);
			tmp = tableau[i];
			tableau[i]=tableau[pos];
			tableau[pos]=tmp;
		}
		return new String(tableau);
	}	

	/**
	 * Gnre un password a partir d'un masque
	 */
	public String genPwd(String masque){
		String charMin="abcdefghijklmnopqrstuvwxyz";
		String charMaj="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		String charNb="0123456789";
		String charSpc=tfSpeciaux.getText();
		String charTout= charMin+charMaj+charNb+charSpc;
		String password="";

		for(int i=0;i<masque.length();i++){
			if(masque.charAt(i)=='a')
				password = password.concat(""+charMin.charAt((int)((Math.random()*1000)%26)));
			else if(masque.charAt(i)=='A')
				password = password.concat(""+charMaj.charAt((int)((Math.random()*1000)%26)));
			else if(masque.charAt(i)=='8')
				password = password.concat(""+charNb.charAt((int)((Math.random()*1000)%10)));
			else if(masque.charAt(i)=='*')
				password = password.concat(""+charSpc.charAt((int)((Math.random()*1000)%charSpc.length())));
			else if(masque.charAt(i)=='\\'){
				password = password.concat(""+masque.charAt(i+1));
				i +=1;
			}
			else	password = password.concat(""+charTout.charAt((int)((Math.random()*1000)%charTout.length())));
		}

		return password;
	}

	/**
	 * Gnre un masque a partir de critres
	 */
	public String genMsq(int MinMin,int MinMaj,int MinNb,int MinSpc,int MaxMin,int MaxMaj,int MaxNb,int MaxSpc,int iLong){
			String strMasque="";
			String strPossible="";

			for (int i=0; i< MinMin;i++) strMasque = strMasque.concat("a");
			for (int i=0; i< MinMaj;i++) strMasque = strMasque.concat("A");
			for (int i=0; i< MinNb;i++) strMasque = strMasque.concat("8");
			for (int i=0; i< MinSpc;i++) strMasque = strMasque.concat("*");

			for (int i=MinMin; i< MaxMin;i++) strPossible = strPossible.concat("a");
			for (int i=MinMaj; i< MaxMaj;i++) strPossible = strPossible.concat("A");
			for (int i=MinNb;  i< MaxNb;i++)  strPossible = strPossible.concat("8");
			for (int i=MinSpc; i< MaxSpc;i++) strPossible = strPossible.concat("*");
			
			strPossible = randomize(strPossible);
			return randomize(strMasque.concat(strPossible.substring(0,iLong-(MinMin + MinMaj + MinNb+ MinSpc))));
	}


	private void genPwdMsq(){
			tfPwd.setText(genPwd(tfMasque.getText()));
	}

	private void genPwdStd(){
		int MinMin, MinMaj, MinNb, MinSpc;
		int MaxMin, MaxMaj, MaxNb, MaxSpc;
		int iLong;

		iLong = Integer.parseInt(tfLongueur.getText());
		if (chkMin.getState()){
			MinMin = Integer.parseInt(tfMinMin.getText());
			MaxMin = Integer.parseInt(tfMaxMin.getText());
		}
		else{ MinMin = 0; MaxMin = 0;}

		if (chkMaj.getState()){
			MinMaj = Integer.parseInt(tfMinMaj.getText());
			MaxMaj = Integer.parseInt(tfMaxMaj.getText());
		}
		else{ MinMaj = 0; MaxMaj = 0;}

		if (chkNb.getState()){
			MinNb = Integer.parseInt(tfMinNb.getText());
			MaxNb = Integer.parseInt(tfMaxNb.getText());
		}
		else{ MinNb = 0; MaxNb = 0;}

		if (chkSpc.getState()){
			MinSpc = Integer.parseInt(tfMinSpc.getText());
			MaxSpc = Integer.parseInt(tfMaxSpc.getText());
		}
		else{ MinSpc = 0; MaxSpc = 0;}

		if ( iLong <(MinMin + MinMaj + MinNb+ MinSpc)){
			tfPwd.setText("Err: somme(min) > longeur");
		}
		else if ( iLong >(MaxMin + MaxMaj + MaxNb + MaxSpc)){
			tfPwd.setText("Err: somme(max) < longeur");
		}
		else 
			tfPwd.setText(genPwd(genMsq(MinMin, MinMaj, MinNb, MinSpc, MaxMin, MaxMaj, MaxNb, MaxSpc,iLong)));
	}

	/**
	 * Gestion des actions
	 */
	public void actionPerformed(ActionEvent actionevent){
		Object obj = actionevent.getSource();
		if(obj == btnGo){
			if(test.getSelectedPanelName() == "Au sujet de ...")
				tfPwd.setText("(c) 2002 Antoine CANONNE");
			else if (test.getSelectedPanelName() == "Standard"){
				genPwdStd();
			}
			else if (test.getSelectedPanelName() == "Masque"){
				genPwdMsq();
			}
		}


	}

	/**
	 * Gestion des selections
	 */
	public void itemStateChanged (ItemEvent evt) { 
		Object obj = evt.getSource();
		if(obj == chkMin){
			if (chkMin.getState()){
				tfMinMin.setEnabled(true);
				tfMinMin.setEditable(true);
				tfMaxMin.setEnabled(true);
				tfMaxMin.setEditable(true);
				chkMin.setForeground(java.awt.Color.black);
			}
			else {
				tfMinMin.setEnabled(false);
				tfMinMin.setEditable(false);
				tfMaxMin.setEnabled(false);
				tfMaxMin.setEditable(false);
				chkMin.setForeground(java.awt.Color.red);
			}
		}
		if(obj == chkMaj){
			if (chkMaj.getState()){
				tfMinMaj.setEnabled(true);
				tfMinMaj.setEditable(true);
				tfMaxMaj.setEnabled(true);
				tfMaxMaj.setEditable(true);
				chkMaj.setForeground(java.awt.Color.black);
			}
			else {
				tfMinMaj.setEnabled(false);
				tfMinMaj.setEditable(false);
				tfMaxMaj.setEnabled(false);
				tfMaxMaj.setEditable(false);
				chkMaj.setForeground(java.awt.Color.red);
			}
		}
		if(obj == chkNb){
			if (chkNb.getState()){
				tfMinNb.setEnabled(true);
				tfMinNb.setEditable(true);
				tfMaxNb.setEnabled(true);
				tfMaxNb.setEditable(true);
				chkNb.setForeground(java.awt.Color.black);
			}
			else {
				tfMinNb.setEnabled(false);
				tfMinNb.setEditable(false);
				tfMaxNb.setEnabled(false);
				tfMaxNb.setEditable(false);
				chkNb.setForeground(java.awt.Color.red);
			}
		}
		if(obj == chkSpc){
			if (chkSpc.getState()){
				tfMinSpc.setEnabled(true);
				tfMinSpc.setEditable(true);
				tfMaxSpc.setEnabled(true);
				tfMaxSpc.setEditable(true);
				tfSpeciaux.setEnabled(true);
				tfSpeciaux.setEditable(true);
				chkSpc.setForeground(java.awt.Color.black);
			}
			else {
				tfMinSpc.setEnabled(false);
				tfMinSpc.setEditable(false);
				tfMaxSpc.setEnabled(false);
				tfMaxSpc.setEditable(false);
				tfSpeciaux.setEnabled(false);
				tfSpeciaux.setEditable(false);
				chkSpc.setForeground(java.awt.Color.red);
			}
		}
	}

}
